#include <stdio.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#define MAX_LEN 20
#define LETTER_WIDTH 5

char text[MAX_LEN] = "REMUS";
int textLen = 5;
int space;

const int letters[][5] = 
{ 
 {0x7e, 0x09, 0x09, 0x09, 0x7e}, //A
 {0x7f, 0x49, 0x49, 0x49, 0x36}, //B
 {0x3e, 0x41, 0x41, 0x41, 0x22}, //C
 {0x7f, 0x41, 0x41, 0x22, 0x1c}, //D
 {0x7f, 0x49, 0x49, 0x49, 0x49}, //E
 {0x7f, 0x09, 0x09, 0x09, 0x09}, //F
 {0x7e, 0x41, 0x49, 0x49, 0x38}, //G
 {0x7f, 0x08, 0x08, 0x08, 0x7f}, //H
 {0x00, 0x41, 0x7f, 0x41, 0x00}, //I
 {0x30, 0x40, 0x41, 0x7f, 0x01}, //J
 {0x7f, 0x08, 0x14, 0x22, 0x41}, //K
 {0x7f, 0x40, 0x40, 0x40, 0x40}, //L
 {0x7f, 0x02, 0x04, 0x02, 0x7f}, //M
 {0x7f, 0x02, 0x0c, 0x10, 0x7f}, //N
 {0x3e, 0x41, 0x41, 0x41, 0x3e}, //O
 {0x7f, 0x49, 0x49, 0x49, 0x36}, //B
 {0x1e, 0x21, 0x21, 0x21, 0x5e}, //Q
 {0x7f, 0x09, 0x19, 0x29, 0x46}, //R
 {0x26, 0x49, 0x49, 0x49, 0x32}, //S
 {0x01, 0x01, 0x7f, 0x01, 0x01}, //T
 {0x3f, 0x40, 0x40, 0x40, 0x3f}, //U
 {0x07, 0x38, 0x40, 0x38, 0x07}, //V
 {0x3f, 0x40, 0x3f, 0x40, 0x3f}, //W
 {0x63, 0x14, 0x08, 0x14, 0x63}, //X
 {0x07, 0x08, 0x70, 0x08, 0x07}, //Y
 {0x61, 0x51, 0x49, 0x45, 0x43} //Z  
};

volatile unsigned char textArray[512];
volatile unsigned int arrLen = 0;
volatile unsigned int arrIx = 0;

void buildTextArray();
void incrSegment();
void initTimer();

int main(){
	sei();
	arrIx = 0;
	arrLen = 0;
	DDRD = 255;
	buildTextArray();
	initTimer();
	while(1){
	}
	return 0;
}

void buildTextArray(void){
	unsigned int i, j;
	for(i = 0; i < textLen; i++){
		for(j = 0; j < LETTER_WIDTH ; j++){
			textArray[arrLen] = letters[text[i] - 'A'][j];
			arrLen = arrLen + 1;
		}
		
		//adauga spatiu intre litere
		for(j = 0; j < LETTER_WIDTH ; j++){
			textArray[arrLen] = 0;
			arrLen = arrLen + 1;
		}
	}
	
	space = textLen * LETTER_WIDTH;
	//adauga spatiu intre cuvinte
	for(i = 0; i < space; i++){
		textArray[arrLen] = 0;
		arrLen = arrLen + 1;
	}
}
void incrSegment(void){
	if(arrIx < arrLen){
		PORTD = textArray[arrIx++];
	} else {
		arrIx = 0;
	}
}
ISR(SIG_OUTPUT_COMPARE1A){
	incrSegment();
}

void initTimer(){
	// initializeaza timer pentru intreruperi 
	OCR1A = 13;
	TCCR1A = 0;
	TCCR1B = (1<<WGM12)|_BV(CS12) | _BV(CS10);
	TIMSK1 |= _BV(OCIE1A);
}
